diff --git a/functional/ControlsTests/test/javafx/scene/control/test/ScrollPane/ScrollPaneTest.java b/functional/ControlsTests/test/javafx/scene/control/test/ScrollPane/ScrollPaneTest.java
--- a/functional/ControlsTests/test/javafx/scene/control/test/ScrollPane/ScrollPaneTest.java
+++ b/functional/ControlsTests/test/javafx/scene/control/test/ScrollPane/ScrollPaneTest.java
@@ -77,6 +77,9 @@
     @Test(timeout = 300000)
     @Covers(value = {"javafx.scene.control.ScrollPane.vmax.DEFAULT", "javafx.scene.control.ScrollPane.vmax.GET"}, level = Level.FULL)
     public void checkVMaxOptionTest() throws InterruptedException {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         Assert.assertEquals((new ScrollPane()).vmaxProperty().getValue(), 1, commonComparePrecision);
 
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.vmax, 200);
@@ -85,17 +88,17 @@
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.vvalue, 200);
         checkTextFieldValue(Properties.vvalue, 200);
 
-        Wrap<? extends ScrollBar> sb1 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
+        Wrap<? extends ScrollBar> sb1 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
         sb1.as(AbstractScroll.class).to(0);
         checkTextFieldValue(Properties.vvalue, 0);
 
-        Wrap<? extends ScrollBar> sb2 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
+        Wrap<? extends ScrollBar> sb2 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
         sb2.as(AbstractScroll.class).to(200);
         checkTextFieldValue(Properties.vvalue, 200);
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(-1 * (Utils.isMacOS() ? -1 : 1));
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(-1 * (Utils.isMacOS() ? -1 : 1));
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(+1 * (Utils.isMacOS() ? -1 : 1));
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(+1 * (Utils.isMacOS() ? -1 : 1));
         checkTextFieldValue(Properties.vvalue, 200);
 
         setPropertyBySlider(SettingType.UNIDIRECTIONAL, Properties.vmax, 150);
@@ -109,6 +112,9 @@
     @Test(timeout = 300000)
     @Covers(value = {"javafx.scene.control.ScrollPane.vmin.DEFAULT", "javafx.scene.control.ScrollPane.vmin.GET"}, level = Level.FULL)
     public void checkVMinOptionTest() throws InterruptedException {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         Assert.assertEquals((new ScrollPane()).vminProperty().getValue(), 0, commonComparePrecision);
 
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.vmin, -100);
@@ -117,17 +123,17 @@
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.vvalue, -100);
         checkTextFieldValue(Properties.vvalue, -100);
 
-        Wrap<? extends ScrollBar> sb1 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
+        Wrap<? extends ScrollBar> sb1 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
         sb1.as(AbstractScroll.class).to(1);
         checkTextFieldValue(Properties.vvalue, 1);
 
-        Wrap<? extends ScrollBar> sb2 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
+        Wrap<? extends ScrollBar> sb2 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
         sb2.as(AbstractScroll.class).to(-100);
         checkTextFieldValue(Properties.vvalue, -100);
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(+1 * (Utils.isMacOS() ? -1 : 1));
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(+1 * (Utils.isMacOS() ? -1 : 1));
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(-1 * (Utils.isMacOS() ? -1 : 1));
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).mouse().turnWheel(-1 * (Utils.isMacOS() ? -1 : 1));
         checkTextFieldValue(Properties.vvalue, -100);
 
         setPropertyBySlider(SettingType.UNIDIRECTIONAL, Properties.vmin, -50);
@@ -141,6 +147,9 @@
     @Test(timeout = 300000)
     @Covers(value = {"javafx.scene.control.ScrollPane.hmax.DEFAULT", "javafx.scene.control.ScrollPane.hmax.GET"}, level = Level.FULL)
     public void checkHMaxOptionTest() throws InterruptedException {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         Assert.assertEquals((new ScrollPane()).hmaxProperty().getValue(), 1, commonComparePrecision);
 
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hmax, 200);
@@ -149,17 +158,17 @@
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hvalue, 200);
         checkTextFieldValue(Properties.hvalue, 200);
 
-        Wrap<? extends ScrollBar> sb1 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
+        Wrap<? extends ScrollBar> sb1 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
         sb1.as(AbstractScroll.class).to(0);
         checkTextFieldValue(Properties.hvalue, 0);
 
-        Wrap<? extends ScrollBar> sb2 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
+        Wrap<? extends ScrollBar> sb2 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
         sb2.as(AbstractScroll.class).to(200);
         checkTextFieldValue(Properties.hvalue, 200);
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(-1);
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(-1);
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(+1);
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(+1);
         checkTextFieldValue(Properties.hvalue, 200);
 
         setPropertyBySlider(SettingType.UNIDIRECTIONAL, Properties.hmax, 150);
@@ -173,6 +182,9 @@
     @Test(timeout = 300000)
     @Covers(value = {"javafx.scene.control.ScrollPane.hmin.DEFAULT", "javafx.scene.control.ScrollPane.hmin.GET"}, level = Level.FULL)
     public void checkHMinOptionTest() throws InterruptedException {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         Assert.assertEquals((new ScrollPane()).vminProperty().getValue(), 0, commonComparePrecision);
 
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hmin, -100);
@@ -181,17 +193,17 @@
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hvalue, -100);
         checkTextFieldValue(Properties.hvalue, -100);
 
-        Wrap<? extends ScrollBar> sb1 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
+        Wrap<? extends ScrollBar> sb1 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
         sb1.as(AbstractScroll.class).to(1);
         checkTextFieldValue(Properties.hvalue, 1);
 
-        Wrap<? extends ScrollBar> sb2 = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
+        Wrap<? extends ScrollBar> sb2 = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
         sb2.as(AbstractScroll.class).to(-100);
         checkTextFieldValue(Properties.hvalue, -100);
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(+1);
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(+1);
 
-        findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(-1);
+        findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).mouse().turnWheel(-1);
         checkTextFieldValue(Properties.hvalue, -100);
 
         setPropertyBySlider(SettingType.UNIDIRECTIONAL, Properties.hmin, -50);
@@ -207,6 +219,9 @@
         Assert.assertEquals((new ScrollPane()).hvalueProperty().getValue(), 0, commonComparePrecision);
         Assert.assertEquals((new ScrollPane()).vvalueProperty().getValue(), 0, commonComparePrecision);
 
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hvalue, 200);
         checkTextFieldValue(Properties.hvalue, 1);
 
@@ -228,11 +243,11 @@
 
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportHeight, 150);
         checkTextFieldValue(Properties.prefViewportHeight, 150);
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) == null);
 
         setPropertyBySlider(SettingType.UNIDIRECTIONAL, Properties.prefViewportHeight, 230);
         checkTextFieldValue(Properties.prefViewportHeight, 230);
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, false) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, false) == null);
     }
 
     /**
@@ -246,11 +261,11 @@
 
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportWidth, 150);
         checkTextFieldValue(Properties.prefViewportWidth, 150);
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) == null);
 
         setPropertyBySlider(SettingType.UNIDIRECTIONAL, Properties.prefViewportWidth, 230);
         checkTextFieldValue(Properties.prefViewportWidth, 230);
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, false) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, false) == null);
     }
 
     @Test(timeout = 300000)
@@ -321,8 +336,8 @@
     };
 
     private void checkScrollbarsVisibility(boolean horizontalVisible, boolean verticalVisible) {
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, horizontalVisible) == null);
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, verticalVisible) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, horizontalVisible) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, verticalVisible) == null);
     }
 
     @Smoke
@@ -372,7 +387,7 @@
                             checkScrollbarsVisibility(true, true);
                             break;
                         case AS_NEEDED:
-                            checkScrollbarsVisibility(true, true);
+                            checkScrollbarsVisibility(false, false);
                             break;
                         case NEVER:
                             checkScrollbarsVisibility(false, false);
@@ -402,6 +417,9 @@
     @ScreenshotCheck
     @Test(timeout = 300000)
     public void dynamicContentChangingTest() throws Throwable {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         changeContent();
         //If content has really changed, button will be searchable.
         //If content didn't change, button won't be on scene.
@@ -443,8 +461,8 @@
             setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, size * 2);
             setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, size * 2);
 
-            Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) == null);
-            Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) == null);
+            Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) == null);
+            Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) == null);
 
             Point controlSize = new GetAction<Point>() {
                 @Override
@@ -460,8 +478,8 @@
                 }
             }.dispatch(Root.ROOT.getEnvironment(), testedControl.getControl());
 
-            double verticalScrollBarWidth = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).getScreenBounds().width;
-            double horizontalScrollBarHeight = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).getScreenBounds().height;
+            double verticalScrollBarWidth = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).getScreenBounds().width;
+            double horizontalScrollBarHeight = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).getScreenBounds().height;
 
             Assert.assertEquals(viewPortSize.x + verticalScrollBarWidth, controlSize.x, commonComparePrecision);
             Assert.assertEquals(viewPortSize.y + horizontalScrollBarHeight, controlSize.y, commonComparePrecision);
@@ -471,6 +489,9 @@
     @ScreenshotCheck
     @Test(timeout = 300000)
     public void whiteGapTest() throws InterruptedException, Throwable {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hmax, 200);
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hmin, 50);
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.hvalue, 200);
@@ -489,6 +510,9 @@
     @ScreenshotCheck
     @Test(timeout = 300000)//RT-17350
     public void immediateHVBarPoliticApplyingTest() throws Throwable {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         setPropertyByChoiceBox(SettingType.BIDIRECTIONAL, ScrollPane.ScrollBarPolicy.ALWAYS, Properties.hbarPolicy);
         setPropertyByChoiceBox(SettingType.BIDIRECTIONAL, ScrollPane.ScrollBarPolicy.NEVER, Properties.hbarPolicy);
 
@@ -531,6 +555,9 @@
     @ScreenshotCheck
     @Test(timeout = 300000)
     public void insideTraversalCheckTest() throws Throwable {
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, 100);
+        setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, 100);
+
         changeContent();
         clickContentButton();
 
@@ -562,14 +589,14 @@
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportWidth, 201);
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportHeight, 201);
 
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, false) == null);
-        Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, false) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, false) == null);
+        Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, false) == null);
 
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportWidth, 200);
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportHeight, 200);
 
-        Assert.assertTrue(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) != null);
-        Assert.assertTrue(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) != null);
+        Assert.assertTrue(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) != null);
+        Assert.assertTrue(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) != null);
 
         currentSettingOption = temp;
     }
@@ -721,8 +748,8 @@
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportHeight, 100);
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefViewportWidth, 100);
 
-        Wrap<? extends ScrollBar> vertical = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
-        Wrap<? extends ScrollBar> horizontal = findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
+        Wrap<? extends ScrollBar> vertical = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true);
+        Wrap<? extends ScrollBar> horizontal = findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true);
 
         ScrollingChecker scV = new ScrollingChecker(vertical.getControl().valueProperty());
         ScrollingChecker scH = new ScrollingChecker(horizontal.getControl().valueProperty());
@@ -765,8 +792,8 @@
             setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefHeight, size * 2);
             setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.prefWidth, size * 2);
 
-            Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) == null);
-            Assert.assertFalse(findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) == null);
+            Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true) == null);
+            Assert.assertFalse(findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true) == null);
 
             Bounds bounds = new GetAction<Bounds>() {
                 @Override
@@ -782,8 +809,8 @@
                 }
             }.dispatch(Root.ROOT.getEnvironment(), testedControl.getControl());
 
-            Assert.assertEquals(viewPortSize.x, bounds.getWidth() + findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).getScreenBounds().getWidth(), commonComparePrecision);
-            Assert.assertEquals(viewPortSize.y, bounds.getHeight() + findScrollBar(testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).getScreenBounds().getHeight(), commonComparePrecision);
+            Assert.assertEquals(viewPortSize.x, bounds.getWidth() + findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.VERTICAL, true).getScreenBounds().getWidth(), commonComparePrecision);
+            Assert.assertEquals(viewPortSize.y, bounds.getHeight() + findScrollBar((Parent<Node>) testedControl.as(Parent.class, Node.class), Orientation.HORIZONTAL, true).getScreenBounds().getHeight(), commonComparePrecision);
         }
     }
 
diff --git a/functional/ControlsTests/test/javafx/scene/control/test/cell/CellsTestBase.java b/functional/ControlsTests/test/javafx/scene/control/test/cell/CellsTestBase.java
--- a/functional/ControlsTests/test/javafx/scene/control/test/cell/CellsTestBase.java
+++ b/functional/ControlsTests/test/javafx/scene/control/test/cell/CellsTestBase.java
@@ -26,11 +26,9 @@
 
 import client.test.Smoke;
 import com.sun.glass.ui.Application;
-import com.sun.javafx.scene.control.skin.LabeledText;
+import com.sun.javafx.scene.control.LabeledText;
 import java.util.ArrayList;
 import java.util.List;
-import java.util.logging.Level;
-import java.util.logging.Logger;
 import javafx.collections.ObservableList;
 import javafx.scene.Node;
 import javafx.scene.Scene;
diff --git a/functional/ControlsTests/test/javafx/scene/control/test/cell/TableCellsTest.java b/functional/ControlsTests/test/javafx/scene/control/test/cell/TableCellsTest.java
--- a/functional/ControlsTests/test/javafx/scene/control/test/cell/TableCellsTest.java
+++ b/functional/ControlsTests/test/javafx/scene/control/test/cell/TableCellsTest.java
@@ -25,7 +25,7 @@
 package javafx.scene.control.test.cell;
 
 import client.test.Smoke;
-import com.sun.javafx.scene.control.skin.LabeledText;
+import com.sun.javafx.scene.control.LabeledText;
 import java.util.Map;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
@@ -155,4 +155,4 @@
             }
         }.dispatch(testedControl.getEnvironment());
     }
-}
\ No newline at end of file
+}
diff --git a/functional/ControlsTests/test/javafx/scene/control/test/choicebox/ChoiceTest.java b/functional/ControlsTests/test/javafx/scene/control/test/choicebox/ChoiceTest.java
--- a/functional/ControlsTests/test/javafx/scene/control/test/choicebox/ChoiceTest.java
+++ b/functional/ControlsTests/test/javafx/scene/control/test/choicebox/ChoiceTest.java
@@ -26,7 +26,7 @@
 
 import client.test.ScreenshotCheck;
 import client.test.Smoke;
-import com.sun.javafx.scene.control.skin.LabeledText;
+import com.sun.javafx.scene.control.LabeledText;
 import javafx.collections.ObservableList;
 import javafx.commons.SortValidator;
 import javafx.scene.Node;
@@ -358,4 +358,4 @@
             checkScreenshot("ChoiceBox-selection" + (i + 1), testPane);
         }
     }
-}
\ No newline at end of file
+}
diff --git a/functional/ControlsTests/test/javafx/scene/control/test/combobox/ComboBoxTest.java b/functional/ControlsTests/test/javafx/scene/control/test/combobox/ComboBoxTest.java
--- a/functional/ControlsTests/test/javafx/scene/control/test/combobox/ComboBoxTest.java
+++ b/functional/ControlsTests/test/javafx/scene/control/test/combobox/ComboBoxTest.java
@@ -33,6 +33,7 @@
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import javafx.beans.value.ObservableValue;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.commons.SortValidator;
@@ -61,6 +62,7 @@
 import javafx.util.Callback;
 import javafx.util.StringConverter;
 import javafx.util.converter.FormatStringConverter;
+import org.jemmy.Point;
 import org.jemmy.action.GetAction;
 import org.jemmy.control.Wrap;
 import org.jemmy.fx.ByStyleClass;
@@ -88,8 +90,6 @@
 /**
  * @author Alexander Kirov
  *
- * Specification:
- * http://xdesign.us.oracle.com/projects/javaFX/fxcontrols-ue/specifications/combobox/combobox.html
  */
 @RunWith(FilteredTestRunner.class)
 public class ComboBoxTest extends TestBase {
@@ -163,13 +163,19 @@
 
         testedControl.mouse().press();
 
-        checkTextFieldText(Properties.armed, "false");
+        checkTextFieldText(Properties.armed, "true");
         checkTextFieldText(Properties.showing, "false");
 
         testedControl.mouse().release();
 
         checkTextFieldText(Properties.armed, "false");
         checkTextFieldText(Properties.showing, "false");
+
+        testedControl.mouse().press();
+        org.jemmy.Rectangle bounds = testedControl.getScreenBounds();
+        testedControl.mouse().move(new Point(bounds.getWidth() + 5, testedControl.getScreenBounds().getHeight() + 5));
+
+        checkTextFieldText(Properties.armed, "false");
     }
 
     @Smoke
@@ -219,7 +225,7 @@
     @ScreenshotCheck
     @Test(timeout = 300000)//RT-19225
     public void promptPropertyTest() throws Throwable {
-        assertEquals((new ComboBox()).promptTextProperty().getValue(), "");
+        assertEquals((new ComboBox()).promptTextProperty().getValue(), null);
 
         //move focus from control. otherwise, we will not see prompt.
         requestFocusOnControl(testedControl);
@@ -335,7 +341,7 @@
         addElement(element3, 2);
         testedControl.as(Selectable.class).selector().select(element3);
         checkSimpleListenerValue(Properties.selectedItem, element3);
-        assertEquals(getTextFieldText(), TO_STRING_PREFIX + "1");
+        assertEquals(getTextFieldText(), TO_STRING_PREFIX + "3");
 
         setPropertyByToggleClick(SettingType.BIDIRECTIONAL, Properties.editable);
         testedControl.as(Selectable.class).selector().select(element2);
@@ -423,13 +429,13 @@
         testedControl.mouse().click();
 
         testedControl.keyboard().pushKey(KeyboardButtons.A);
+        checkCounterValue(ON_ACTION_EVENT_COUNTER_ID, 3);
+        testedControl.keyboard().pushKey(KeyboardButtons.ENTER);
         checkCounterValue(ON_ACTION_EVENT_COUNTER_ID, 4);
-        testedControl.keyboard().pushKey(KeyboardButtons.ENTER);
-        checkCounterValue(ON_ACTION_EVENT_COUNTER_ID, 5);
         setPropertyByTextField(SettingType.BIDIRECTIONAL, Properties.value, NEW_VALUE_1);
-        checkCounterValue(ON_ACTION_EVENT_COUNTER_ID, 7);
+        checkCounterValue(ON_ACTION_EVENT_COUNTER_ID, 6);
         setPropertyByTextField(SettingType.UNIDIRECTIONAL, Properties.value, NEW_VALUE_2);
-        checkCounterValue(ON_ACTION_EVENT_COUNTER_ID, 9);
+        checkCounterValue(ON_ACTION_EVENT_COUNTER_ID, 8);
     }
 
     @Smoke
@@ -641,7 +647,9 @@
         addElements(1, 2, 3, 4, 5, 6);
         setPropertyBySlider(SettingType.BIDIRECTIONAL, Properties.visibleRowCount, 5);
         clickDropDownButton();
-        Wrap<? extends ScrollBar> sb = findScrollBar(((Wrap<? extends ListView>) getPopupWrap().as(Parent.class, Node.class).lookup(ListView.class).wrap()).as(Parent.class, Node.class), Orientation.VERTICAL, true);
+        Wrap<? extends ScrollBar> sb = findScrollBar(
+                ((Parent<Node>) ((Wrap<? extends ListView>) ((Parent<Node>) getPopupWrap().as(Parent.class, Node.class))
+                .lookup(ListView.class).wrap()).as(Parent.class, Node.class)), Orientation.VERTICAL, true);
         sb.as(AbstractScroll.class).caret().to(1);
         checkTextFieldText(Properties.showing, "true");
         testedControl.as(Selectable.class).selector().select("6");
@@ -699,12 +707,12 @@
         checkSelectionState(5, 6);
         assertEquals(getTextFieldText(), "6");
         checkTextFieldText(Properties.value, "6");
+        checkSimpleListenerValue(Properties.selectedIndex, 5);
 
         testedControl.mouse().click();
         testedControl.as(Text.class).type("abc");
         testedControl.keyboard().pushKey(KeyboardButtons.ENTER);
 
-        checkSimpleListenerValue(Properties.selectedIndex, 5);
         checkSimpleListenerValue(Properties.selectedItem, "6abc");
         checkTextFieldText(Properties.value, "6abc");
 
@@ -1273,8 +1281,6 @@
                 setPropertyByToggleClick(SettingType.UNIDIRECTIONAL, Properties.editable);
             }
 
-            Wrap<? extends javafx.scene.text.Text> textFieldWrap = testedControl.as(Parent.class, Node.class)
-                    .lookup(javafx.scene.text.Text.class).wrap();
             final double initialButtonHeight = testedControl.getScreenBounds().getHeight();
             double prevCellTextHeight = 0f;
 
@@ -1287,6 +1293,8 @@
                 assertEquals(initialButtonHeight, testedControl.getScreenBounds().getHeight(), 0.001);
 
                 /* text node should be alwas rendered inside ComboBox button */
+                Wrap<? extends javafx.scene.text.Text> textFieldWrap = testedControl.as(Parent.class, Node.class)
+                    .lookup(javafx.scene.text.Text.class).wrap();
                 assertTrue(textFieldWrap.getScreenBounds().getY() >= testedControl.getScreenBounds().getY());
                 assertTrue(textFieldWrap.getScreenBounds().getY() + textFieldWrap.getScreenBounds().getHeight()
                         <= testedControl.getScreenBounds().getY() + testedControl.getScreenBounds().getHeight());
@@ -1422,7 +1430,7 @@
 
         testedControl.keyboard().pushKey(KeyboardButtons.ENTER);
 
-        checkTextFieldText(Properties.value, FROM_STRING_PREFIX + "1");
+        checkTextFieldText(Properties.value, FROM_STRING_PREFIX);
     }
 
     /**
@@ -1647,4 +1655,4 @@
             clickDropDownButton();
         }
     }
-}
\ No newline at end of file
+}
diff --git a/functional/ControlsTests/test/javafx/scene/control/test/combobox/TestBase.java b/functional/ControlsTests/test/javafx/scene/control/test/combobox/TestBase.java
--- a/functional/ControlsTests/test/javafx/scene/control/test/combobox/TestBase.java
+++ b/functional/ControlsTests/test/javafx/scene/control/test/combobox/TestBase.java
@@ -245,7 +245,8 @@
     protected void checkScrollBarVisibility(boolean visible) throws InterruptedException {
         Wrap<? extends Scene> popup = getPopupWrap();
         if (popup != null) {
-            Assert.assertTrue(findScrollBar(((Wrap<? extends ListView>) popup.as(Parent.class, Node.class).lookup(ListView.class).wrap()).as(Parent.class, Node.class), Orientation.VERTICAL, visible) != null);
+            Assert.assertTrue(findScrollBar(((Parent<Node>) ((Wrap<? extends ListView>) ((Parent<Node>) popup.as(Parent.class, Node.class))
+                    .lookup(ListView.class).wrap()).as(Parent.class, Node.class)), Orientation.VERTICAL, visible) != null);
         }
     }
 
